﻿using System;
using System.Windows.Input;

namespace DependencyInjectionExample.DiConstructor
{
    public class DiConstructorViewModelShowMessage
    {
        private static ShowMessage writer = new DependencyInjectionExample.DiConstructor.ShowMessage();
        private ICommand _buttonCommand;
        private DoTheMessageIoC _doTheMessage = new DoTheMessageIoC(writer);

        public ICommand ButtonClick
        {
            get { return _buttonCommand; }
            set { _buttonCommand = value; }
        }

        public DiConstructorViewModelShowMessage()
        {
            ButtonClick = new DiConstructorCommand(new Action<object>(_doTheMessage.Notify));
        }
    }

    public class DiConstructorViewModelWriteMesage
    {
        private static WriteMessageToFile writer = new DependencyInjectionExample.DiConstructor.WriteMessageToFile();
        private ICommand _buttonCommand;
        private DoTheMessageIoC _doTheMessage = new DoTheMessageIoC(writer);

        public ICommand ButtonClick
        {
            get { return _buttonCommand; }
            set { _buttonCommand = value; }
        }

        public DiConstructorViewModelWriteMesage()
        {
            ButtonClick = new DiConstructorCommand(new Action<object>(_doTheMessage.Notify));
        }
    }
}