﻿using System;
using System.Windows.Input;

namespace DependencyInjectionExample.IoC
{
    public class IoCViewModelShowMessage
    {
        private ICommand _buttonCommand;
        private DoTheMessageIoC _doTheMessage = new DoTheMessageIoC();

        public ICommand ButtonClick
        {
            get { return _buttonCommand; }
            set { _buttonCommand = value; }
        }

        public IoCViewModelShowMessage()
        {
            ButtonClick = new IoCCommand(new Action<object>(_doTheMessage.ShowMesage));
        }
    }

    public class IoCViewModelWriteMesage
    {
        private ICommand _buttonCommand;
        private DoTheMessageIoC _doTheMessage = new DoTheMessageIoC();

        public ICommand ButtonClick
        {
            get { return _buttonCommand; }
            set { _buttonCommand = value; }
        }

        public IoCViewModelWriteMesage()
        {
            ButtonClick = new IoCCommand(new Action<object>(_doTheMessage.WriteMessage));
        }
    }
}
