﻿using System;
using System.Windows.Input;

namespace DependencyInjectionExample.WithoutDi
{
    public class WithoutDiViewModelShowMessage
    {
        private ICommand _buttonCommand;
        DoTheMessageWithoutDi _doTheMessage = new DoTheMessageWithoutDi();


        public ICommand ButtonClick
        {
            get { return _buttonCommand; }
            set { _buttonCommand = value; }
        }

        public WithoutDiViewModelShowMessage()
        {
            ButtonClick = new WithoutDiCommand(new Action<object>(_doTheMessage.ShowMesage));
        }
    }

    public class WithoutDiViewModelWriteMesage
    {
        private ICommand _buttonCommand;
        DoTheMessageWithoutDi _doTheMessage = new DoTheMessageWithoutDi();


        public ICommand ButtonClick
        {
            get { return _buttonCommand; }
            set { _buttonCommand = value; }
        }

        public WithoutDiViewModelWriteMesage()
        {
            ButtonClick = new WithoutDiCommand(new Action<object>(_doTheMessage.WriteMessage));
        }
    }
}